## qi 20111113

=== Makefile ===
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#

include config.mk

BUILD_DATE := $(shell date --iso-8601=seconds)
BUILD_HOST := $(shell hostname)
BUILD_BRANCH ?= $(shell git branch | grep ^\* | cut -d' ' -f2)
BUILD_HEAD ?= $(shell git show --pretty=oneline | head -n1 | cut -d' ' -f1 | cut -b1-16)
BUILD_VERSION := ${BUILD_BRANCH}_${BUILD_HEAD}

LDS	= src/cpu/$(CPU)/qi.lds
INCLUDE	= include
IMAGE_DIR	= image
TOOLS	= tools
CFLAGS	= -Wall -Werror -I $(INCLUDE) -g -c -Os -fno-strict-aliasing -mlong-calls \
	  -fno-common -ffixed-r8 -msoft-float -fno-builtin -ffreestanding \
	  -march=armv4t -mno-thumb-interwork -Wstrict-prototypes \
	  -DBUILD_HOST="${BUILD_HOST}" -DBUILD_VERSION="${BUILD_VERSION}" \
	  -DBUILD_DATE="${BUILD_DATE}" -DQI_CPU="${CPU}"
LDFLAGS = 

S_SRCS	= $(wildcard src/cpu/$(CPU)/*.S)
S_OBJS	= $(patsubst %.S,%.o, $(S_SRCS))
C_SRCS	= $(wildcard src/*.c) \
	  $(wildcard src/drivers/*.c)  $(wildcard src/fs/*.c) \
	  $(wildcard src/cpu/$(CPU)/*.c)
C_OBJS	= $(patsubst %.c,%.o, $(C_SRCS))

SRCS	= ${S_SRCS} ${C_SRCS}
OBJS	= ${S_OBJS} ${C_OBJS}
LIBS	= `$(CC) -print-libgcc-file-name`

ifeq ($(CPU),s3c2410)
  # GTA01 U-Boot IDs
  UDFU_VID = 0x1457
  UDFU_PID = 0x5119
  UDFU_REV = 0x0240
else
  # GTA02 A5 and A6 U-Boot will eat these for DFU action
  UDFU_VID = 0x1d50
  UDFU_PID = 0x5119
  UDFU_REV = 0x350
endif

TARGET	= $(IMAGE_DIR)/start_qi_all-$(CPU)
IMAGE = $(IMAGE_DIR)/qi-$(CPU)-$(BUILD_VERSION)
UDFU_IMAGE = $(IMAGE_DIR)/qi-$(CPU)-$(BUILD_VERSION).udfu

MKUDFU = $(TOOLS)/mkudfu

%.o: %.S
	$(CC) $(CFLAGS) -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -o $@ $<

all:${UDFU_IMAGE}

${OBJS}:${SRCS} ${INCLUDE}/*.h

${MKUDFU}:
	 make -C $(TOOLS)

${UDFU_IMAGE}:${OBJS} ${MKUDFU}
	mkdir -p image
	$(LD) ${LDFLAGS} -T$(LDS) -g $(OBJS) -o ${TARGET} ${LIBS}
	$(OBJCOPY) -O binary -S ${TARGET} ${IMAGE}
	$(MKUDFU) -v ${UDFU_VID} -p ${UDFU_PID} -r ${UDFU_REV} \
						-d ${IMAGE} ${UDFU_IMAGE}
	$(OBJDUMP) -d ${TARGET} >${IMAGE}.dis

clean:
	@rm -f *~ src/*.o src/*~
	@rm -f src/cpu/*/*.o src/cpu/*/*~
	@rm -f src/drivers/*.o src/drivers/*~
	@rm -f src/fs/*.o src/fs/*~
	@rm -f include/*~ ${IMAGE_DIR}/*
	@make clean -C $(TOOLS)

=== tools/Makefile ===
#(C) Copyright 2007 OpenMoko, Inc.
# Author: xiangfu liu <xiangfu@openmoko.org>
#
# Configuation settings for the OPENMOKO Neo GTA02 Linux GSM phone
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#
include ../config.mk

CC	= ${HOSTCC}
CFLAGS	= -Wall
C_SRCS	= $(wildcard *.c)
C_OBJS	= $(patsubst %.c,%.o, $(C_SRCS))
SRCS	= ${C_SRCS}
OBJS	= ${C_OBJS}
TARGET	= mkudfu

%.o: %.c
	CC $(CFLAGS) -o $@ $<

all:${TARGET}

${TARGET}:${SRCS}

clean:
	@rm -f *.o  *~  ${TARGET}

=== debian/changelog ===
qi (20111113-1) unstable; urgency=low

  * New upstream release
     - Add support for two boot options even when there is only one
       partition
     - Add support for initrd (/boot/initrd-GTA02.bin)
     - Change NAND kernel boot parameters to use rootfstype=ubifs
       instead of jffs2. It is now possible to dualboot SHR and Debian.
       Tested with
       http://shr.bearstech.com/shr-core/images/om-gta02/uImage-2.6.39-r6-oe13-om-gta02-20111031080338.bin
       http://shr.bearstech.com/shr-core/images/om-gta02/shr-full-20111109-om-gta02.rootfs.ubi
  * Remove upstreamed patch fix-build-with-gcc-4.6.diff
  * Document how qi can be installed using old versions of mtd-utils
  * Write a man page

 -- Timo Juhani Lindfors <timo.lindfors@iki.fi>  Sat, 12 Nov 2011 18:18:51 +0200

qi (20100107-1) unstable; urgency=low

  * Initial release (Closes: #629404)

 -- Timo Juhani Lindfors <timo.lindfors@iki.fi>  Sun, 05 Jun 2011 22:43:21 +0300

=== debian/control ===
Source: qi
Section: admin
Priority: optional
Maintainer: Timo Juhani Lindfors <timo.lindfors@iki.fi>
Build-Depends: debhelper (>= 8)
Standards-Version: 3.9.2
Homepage: http://wiki.openmoko.org/wiki/Qi
Vcs-Git: git://git.debian.org/pkg-fso/qi.git
Vcs-Browser: http://git.debian.org/?p=pkg-fso/qi.git;a=summary

Package: qi
Architecture: armel
Depends: ${misc:Depends}
Description: lightweight bootloader for OpenMoko Freerunner
 Qi (named by Alan Cox on Openmoko kernel list) is a minimal
 bootloader that "breathes life" into Linux.  Its goal is to stay
 close to the minimum needed to "load" and then "boot" Linux -- no
 boot menus, additional peripheral init or private states.

=== debian/rules ===
#!/usr/bin/make -f
VERSION := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
UPSTREAM_VERSION := $(shell echo $(VERSION) | cut -d - -f1)
UPSTREAM_VERSION_UNIXDATE := $(shell date -u -d $(UPSTREAM_VERSION) +%s)
%:
	dh $@
override_dh_auto_build:
	$(MAKE) CPU=s3c2442 CROSS_COMPILE="" BUILD_BRANCH=debian BUILD_HEAD=$(VERSION)
override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/qi/usr/lib/qi/gta02/
	install -m 644 image/qi-s3c2442-debian_$(VERSION) $(CURDIR)/debian/qi/usr/lib/qi/gta02/qi
	install -m 644 image/qi-s3c2442-debian_$(VERSION).udfu $(CURDIR)/debian/qi/usr/lib/qi/gta02/qi.udfu
	mkdir -p $(CURDIR)/debian/qi/usr/share/man/man8
	install -m 644 debian/qi.8 $(CURDIR)/debian/qi/usr/share/man/man8/qi.8
get-orig-source:
	@echo version $(VERSION)
	@echo upstream version $(UPSTREAM_VERSION)
	@echo unixdate $(UPSTREAM_VERSION_UNIXDATE)
	git clone git://git.openmoko.org/git/qi qi-$(UPSTREAM_VERSION)
	cd qi-$(UPSTREAM_VERSION) && git reset --hard `git rev-list --all -n 1 --before=$(UPSTREAM_VERSION_UNIXDATE)`
	cd qi-$(UPSTREAM_VERSION) && git archive --format=tar --prefix=qi-$(UPSTREAM_VERSION)/ master | gzip -9 --no-name > ../qi_$(UPSTREAM_VERSION).orig.tar.gz
	rm -fr qi-$(UPSTREAM_VERSION)

=== debian/watch ===
# Upstream does not make releases so there are no releases to watch,
# we just need to package git snapshots for now.
